unit MathLib;

interface

uses
  SysUtils, Classes, Math;

type TMathLib = Class(Tobject)
  private
    ASin  : array [0..1023] of Integer; //Sin,Cose|u
    AATan : array [0..1023] of Integer; //ATANe[u

    RT : array[0..1023] of Integer;     //Randome|u
  public
    RndStep : Integer;                  //RandomĂяop

    constructor Create;
    //w֐
    function  Rnd(Max : Integer) : Integer;  //(0    - MAX)
    function  Rnd2(Max : Integer) : Integer; //    (-MAX - MAX)
    function  SinF(r : Single) : Single;    //^
    function  CosF(r : Single) : Single;
    function  AtanF(x,y : Single) : Single;
    function  SinI(r : Integer) : Integer; //^ix1024j
    function  CosI(r : Integer) : Integer;
    function  AtanI(x,y : Integer) : Integer;

    procedure SaveRandomTable(fileName : string);
    procedure LoadRandomTable(fileName : string);
    procedure InitRandom(x : Integer);
end;

    function  SignI(x : Integer) : Integer;
    function  AbsI(x : Integer) : Integer;
    function  Spline(const p1,p2,p3,p4:Single; const rate:Single) : Single;


implementation

//------------------------------------------------------------------------------
//
constructor TMathLib.Create;
var
  i : Integer;
begin
  inherited Create;
  //SinTable    igό`Ɏgj
  for i := 0 to 1023 do
    ASin[i] := round(sin(3.14159265*(i/512))*1024);
  //ATanTable
  { := 0;
  for j := 0 to 128 do
  begin
    aaa := round(sin(3.141592 * j / 512) / cos(3.141592 * j / 512) * 1024);
    for k := 0 to aaa - i do
    begin
      AATAN[i+k] := j;
    end;
    i := aaa;
  end;
  for k := 0 to 1023 - i do
  begin
    AATAN[i+k] := 128;
  end;                    }
  //RandomTable  (mCYɎgj
  randomize;
  for i := 0 to 1023 do
    RT[i] := random(4095);
  RndStep := 0;
end;

//------------------------------------------------------------------------------
//̐
function TMathLib.Rnd(Max : Integer) : Integer;
begin
  Inc(RndStep);
  RndStep := RndStep and $3FF;
  result := (RT[RndStep]*Max) shr 12;
end;

//------------------------------------------------------------------------------
//̐
function TMathLib.Rnd2(Max : Integer) : Integer;
begin
  Inc(RndStep);
  RndStep := RndStep and $3FF;
  result := (RT[RndStep]*Max*2) shr 12;
  result := result - Max;
end;


//---------------------------------------------------------------
//SiňĂяo(WAp^)
// 0<r<2Pai
function TMathLib.SinF(r : single) : Single;
var
  aaa : Integer;
begin
  aaa := round(r/3.14159*512);
  result := SinI(aaa) / 1024;
end;
//---------------------------------------------------------------
//CošĂяo(WAp^)
// 0<r<2Pai
function TMathLib.CosF(r : single) : single;
var
  aaa : Integer;
begin
  aaa := round(r/3.14159*512);
  result := CosI(aaa) / 1024;
end;
//---------------------------------------------------------------
//SiňĂяo(1024p^)
// 0<r<1024
function TMathLib.SinI(r : Integer) : Integer;
var
  aaa : Integer;
begin
  aaa := r;
  Inc(aaa,4096);
  aaa := aaa and $3FF;
  result := ASin[aaa];
end;
//---------------------------------------------------------------
//SiňĂяo(1024p^)
// 0<r<1024
function TMathLib.CosI(r : Integer) : Integer;
var
  aaa : Integer;
begin
  aaa := r;
  Inc(aaa,4352); // 4096(360) + 256(90)
  aaa := aaa and $3FF;
  result := ASin[aaa];
end;
//---------------------------------------------------------------
//ATAŇĂяo(1024p^)
//
function  TMathLib.AtanI(x,y : Integer) : Integer;
var
  aaa : Integer;
begin
  if ((x = 0) and (y = 0))then
  begin
    result := 0;
    Exit;
  end;
  aaa := round(ArcTan2(y,x)*1024/6.2831853);
  inc (aaa,4096);
  result := (aaa and $3FF); 
  {
  if (x > 0)then

    if (y > 0)then
      if (x > y)then res := AATAN[y shl 10 div x]
		else res := 256 - AATAN[x shl 10 div y]
    else
    begin
      y := -y;
      if (x > y)then res := 1024 - AATAN[y shl 10 div x]
                else res := 768 + AATAN[x shl 10 div y];
    end

  else
    if (y > 0)then
    begin
      x := -x;
      if (x > y)then res := 512 -  AATAN[y shl 10 div x]
		else res := 256 + AATAN[x shl 10 div y];
    end
    else
    begin
      x := -x;
      y := -y;
      if (x > y)then res := 512 +  AATAN[y shl 10 div x]
		else res := 768 - AATAN[x shl 10 div y];
    end;

  result := res;
   }
end;
//---------------------------------------------------------------
//ATAŇĂяo(2Paip^)
//
function  TMathLib.AtanF(x,y : single) : single;
var
  res : Integer;
begin
  if ((x = 0) and (y = 0))then
  begin
    result := 0;
    Exit;
  end;

  if (x > 0)then

    if (y > 0)then
      if (x > y)then res := AATAN[trunc(y * 1024 / x)]
		else res := 256 - AATAN[trunc(x * 1024 / y)]
    else
    begin
      y := -y;
      if (x > y)then res := 1024 - AATAN[trunc(y * 1024 / x)]
                else res := 768 + AATAN[trunc(x * 1024 / y)];
    end

  else
    if (y > 0)then
    begin
      x := -x;
      if (x > y)then res := 512 -  AATAN[trunc(y * 1024 / x)]
		else res := 256 + AATAN[trunc(x * 1024 / y)];
    end
    else
    begin
      x := -x;
      y := -y;
      if (x > y)then res := 512 +  AATAN[trunc(y * 1024 / x)]
		else res := 768 - AATAN[trunc(x * 1024 / y)];
    end;

  result := (res*3.1415926/512);
end;

//---------------------------------------------------------------
//e|ȕ
procedure TMathLib.SaveRandomTable(fileName : string);
var
  ff : file;
begin
  AssignFile(ff,FileName);
  ReWrite(FF,1);
  BlockWrite(ff,RT,sizeof(RT));
  CloseFile(ff);
end;

//---------------------------------------------------------------
//e|u̓ǂݍ
procedure TMathLib.LoadRandomTable(fileName : string);
var
  ff : file;
begin
  if (FileExists(FileName) = True)then
  begin
    AssignFile(ff,FileName);
    ReSet(FF,1);
    BlockRead(ff,RT,sizeof(RT));
    CloseFile(ff);
  end;
end;

//------------------------------------------------------------------------------
//e[uʒu̎w
procedure TMathLib.InitRandom(x : Integer);
begin
  RndStep := x;
end;

//------------------------------------------------------------------------------
//Βl
function AbsI(x : Integer) : Integer;
begin
  if (x < 0)then result := not(x-1)
            else result := x;
end;

//------------------------------------------------------------------------------
//߂(1 or -1)
function SignI(x : Integer) : Integer;
begin
  if (x < 0)then result := -1
            else result := 1;
end;

//------------------------------------------------------------------------------
//XvC(4_^āA2_̃uh^ĕ
function Spline(const p1,p2,p3,p4:Single; const rate:Single) : Single;
var
  ir:Single;      //1-rate
  r2,r3:Single;   //rate^2@, rate^3
begin
  ir:=1-rate;
  r2:=rate*rate;
  r3:=r2*rate;

  result := ( (p1*ir*ir*ir) + p2*(3*r3-6*r2+4) + p3*(-3*(r3-r2-rate)+1) + p4*r3) / 6.0;
end;

end.
