unit render;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, math;

//_Op32BitO[XP[̈
type TRendSurface = record
  bmp : array[0..255,0..255] of WORD;
end;

//p[eBN摜p8BitO[XP[̈
type TParticleSurface = record
  bmp : array[0..63,0..63] of BYTE;
end;

function SwapColor(col : DWORD) : DWORD;
procedure RSclear(var dest : TRendSurface);
procedure RSFeedBack(var dest : TrendSurface; alpha : Integer);
procedure RSPutAdd(var dest : TRendSurface; x,y : Integer;
                   src : TParticleSurface; Alpha,rot,size : Integer);
function  RSIfBit(dest : TRendSurface) : Integer;
procedure RStoBmp(dest : TBitmap; dx,dy,dw,dh : Integer;
                  src : TRendSurface; ColorMap : array  of DWORD);
function  GetColorMap(ColorMap : array of DWORD; aaa : Integer) : Integer;
procedure RSToneCurve(var dest : TrendSurface; tone : array of Integer);

implementation

//------------------------------------------------------------------------------
//J[̂qƂaւ
function SwapColor(col : DWORD) : DWORD;
var
  rr,gg,bb : Integer;
begin
  rr := (col shr 16) and $FF;
  gg := (col shr  8) and $FF;
  bb := (col       ) and $FF;
  result := rr or (gg shl 8) or (bb shl 16);
end;

//------------------------------------------------------------------------------
procedure RSclear(var dest : TRendSurface);
var
  j,i : Integer;
begin
  for i:=0 to 255 do
    for j:=0 to 255 do
      dest.bmp[i,j] := 0;
end;

//------------------------------------------------------------------------------
procedure RSFeedBack(var dest : TrendSurface; alpha : Integer);
var
  j,i : Integer;
begin
  for i:=0 to 255 do
    for j:=0 to 255 do
       dest.bmp[i,j] := dest.bmp[i,j] * alpha shr 10;
end;

//------------------------------------------------------------------------------
procedure RSPutAdd(var dest : TRendSurface; x,y : Integer;
                src : TParticleSurface; Alpha,rot,size : Integer);
var
  j,i,dx1,dy1,dx2,dy2,sx1,sy1,sx2,sy2 : Integer;
  col1,col2 : Integer;
begin
  dx1 := x - 32;
  dy1 := y - 32;
  dx2 := x + 32;
  dy2 := y + 32;

  sx1 := 0;
  sy1 := 0;
  sx2 := 64;
  sy2 := 64;

  if (dx2 < 0)then exit;
  if (dx1 > 255)then exit;
  if (dy2 < 0)then exit;
  if (dy1 > 255)then exit;

  if (dx1 < 0)then
  begin
    sx1 := sx1 - dx1;
    dx1 := 0;
  end;
  if (dy1 < 0)then
  begin
    sy1 := sy1 - dy1;
    dy1 := 0;
  end;
  if (dx2 > 255)then
  begin
    sx2 := sx2 - (dx2 - 255);
    dx2 := 255;
  end;
  if (dy2 > 255)then
  begin
    sy2 := sy2 - (dy2 - 255);
    dy2 := 255;
  end;

  for i:=0 to sy2-sy1-1 do
    for j:=0 to sx2-sx1-1 do
    begin
      col1 := Dest.bmp[i+dy1,j+dx1];
      col2 := Src.bmp[i+sy1,j+sx1];
      col2 := (col2 shl 8) * alpha shr 10;
      col1 := col1 + col2;
      if (col1 > 65535)then col1 := 65535;
      Dest.bmp[i+dy1,j+dx1] := col1;
    end;
end;

function  RSIfBit(dest : TRendSurface) : Integer;
var
  prt : PWORD;
  i,aaa : Integer;
begin
  prt := @dest.bmp[0,0];
  aaa := 0;
  for i:=0 to 256*256-1 do
  begin
    aaa := aaa or prt^;
    inc(prt);
  end;
  result := aaa;
end;

//------------------------------------------------------------------------------
procedure RStoBmp(dest : TBitmap; dx,dy,dw,dh : Integer;
                  src : TRendSurface; ColorMap : array  of DWORD);
var
  j,i,k,m,col,cw,ch : Integer;
  rr,gg,bb: array[0..7] of Integer;
  prt : PDWORD;
procedure InitColorMap;
var
  iii : Integer;
begin
  for iii:=0 to 7 do
  begin
    rr[iii] := (ColorMap[iii] shr 16) and $FF;
    gg[iii] := (ColorMap[iii] shr  8) and $FF;
    bb[iii] := (ColorMap[iii]       ) and $FF;
  end;
end;
function GetColor(col : Integer) : Integer;
var
  aa1,aa2,aa3,rrr,ggg,bbb : Integer;
begin
  if (col < 1)then
  begin
    result := ColorMap[0];
    exit;
  end;
  if (col > 65534)then
  begin
    result := ColorMap[7];
    exit;
  end;
  //[ƕ
  aa1 := col div 9363;
  aa2 := col mod 9363;
  aa3 := 9363 - aa2;
  rrr := (rr[aa1]*aa3 + rr[aa1+1]*aa2) div 9363;
  ggg := (gg[aa1]*aa3 + gg[aa1+1]*aa2) div 9363;
  bbb := (bb[aa1]*aa3 + bb[aa1+1]*aa2) div 9363;
  result := (rrr shl 16) or (ggg shl 8) or bbb;
end;
begin
  InitColorMap;
  cw := 256 div dw;
  ch := 256 div dh;
  if ((cw = 1)and(ch = 1))then
  begin
    for i:=0 to 255 do
    begin
      prt := dest.ScanLine[i+dy];
      inc(prt,dx);
      for j:=0 to 255 do
        begin
        prt^ := GetColor(src.bmp[i,j]);
        inc(prt);
      end;
    end;
  end
  else
  begin
    for i:=0 to dh-1 do
    begin
      prt := dest.ScanLine[dy+i];
      inc(prt,dx);
      for j:=0 to dw-1 do
      begin
        col := 0;
        for k:=0 to ch-1 do
          for m:=0 to cw-1 do
            col := col + src.bmp[i*ch+k,j*cw+m];
        col := col div (ch*cw);
        prt^ := GetColor(col);
        inc(prt);
      end;
    end;
  end;
end;

//------------------------------------------------------------------------------
function  GetColorMap(ColorMap : array of DWORD; aaa : Integer) : Integer;
var
  aa1,aa2,aa3,rrr,ggg,bbb : Integer;
begin
  if (aaa < 1)then
  begin
    result := ColorMap[0];
    exit;
  end;
  if (aaa > 1022)then
  begin
    result := ColorMap[7];
    exit;
  end;
  //[ƕ
  aa1 := aaa div 147;
  aa2 := aaa mod 147;
  aa3 := 147 - aa2;
  rrr := (((ColorMap[aa1] shr 16) and $FF)*aa3 + ((ColorMap[aa1+1] shr 16) and $FF)*aa2) div 147;
  ggg := (((ColorMap[aa1] shr  8) and $FF)*aa3 + ((ColorMap[aa1+1] shr  8) and $FF)*aa2) div 147;
  bbb := (((ColorMap[aa1]       ) and $FF)*aa3 + ((ColorMap[aa1+1]       ) and $FF)*aa2) div 147;
  result := (rrr shl 16) or (ggg shl 8) or bbb;
end;

//------------------------------------------------------------------------------
procedure RSToneCurve(var dest : TrendSurface; tone : array of Integer);
var
  i,j,aa1,aa2,col : Integer;
  atone : array[0..31] of Integer;
begin
  for i:=0 to 31 do
  begin
    atone[i] := tone[i] * 64;
    if (atone[i] > 65535)then atone[i] := 65535;
    if (atone[i] < 0    )then atone[i] := 0;
  end;
  for i:=0 to 255 do
    for j:=0 to 255 do
    begin
      col := dest.bmp[i,j];
      if (col < 1    )then
      begin
        dest.bmp[i,j] := atone[0];
        continue;
      end;
      if (col > 65534)then
      begin
        dest.bmp[i,j] := atone[31];
        continue;
      end;
      aa1 := col div 2115;
      aa2 := col mod 2115;
      col := (atone[aa1]*(2115-aa2) + atone[aa1+1]*aa2) div 2115;
      dest.bmp[i,j] := col;
    end;
end;

end.
 